"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var NFGSHandlerClass = /** @class */ (function () {
    function NFGSHandlerClass() {
        var _this = this;
        this.listeners = {};
        process.stdin.on("data", function (args) {
            var data = JSON.parse(Buffer.from(args).toString());
            if (_this.listeners[data.eventName] !== undefined) {
                _this.listeners[data.eventName].forEach(function (x) { return x(data.data); });
            }
        });
    }
    NFGSHandlerClass.prototype.stdoutSend = function (arg) {
        process.stdout.write(JSON.stringify(arg));
    };
    NFGSHandlerClass.prototype.sendMessage = function (eventName, data) {
        this.stdoutSend({
            command: "event",
            eventName: eventName,
            data: data
        });
    };
    NFGSHandlerClass.prototype.addListener = function (eventName, func) {
        if (this.listeners[eventName] === undefined) {
            this.listeners[eventName] = [];
        }
        this.listeners[eventName][this.listeners[eventName].length] = func;
    };
    NFGSHandlerClass.prototype.print = function (arg) {
    };
    return NFGSHandlerClass;
}());
var NFGSHandler = new NFGSHandlerClass();
exports.NFGSHandler = NFGSHandler;
NFGSHandler.addListener("say", function (x) {
    console.oldLog(x);
});
console.oldLog = console.log;
console.log = (function () {
    return function (message) {
        var optionalParems = [];
        for (var _i = 1; _i < arguments.length; _i++) {
            optionalParems[_i - 1] = arguments[_i];
        }
        var arg = {};
        if (optionalParems.length === 0) {
            arg = message;
        }
        else {
            arg = [message].concat(optionalParems);
        }
    };
})();
//# sourceMappingURL=index.js.map